﻿using System;

using Android.App;
using Android.Content.PM;
using Android.Runtime;
using Android.Views;
using Android.Widget;
using Android.OS;
using Forms = Syncfusion.SfChart.XForms;
using Syncfusion.SfChart.XForms.Droid;
using Com.Syncfusion.Charts;
using System.Reflection;

namespace Chart_GettingStarted.Droid
{
    [Activity(Label = "Chart_GettingStarted", Icon = "@drawable/icon", Theme = "@style/MainTheme", MainLauncher = true, ConfigurationChanges = ConfigChanges.ScreenSize | ConfigChanges.Orientation)]
    public class MainActivity : global::Xamarin.Forms.Platform.Android.FormsAppCompatActivity
    {
        protected override void OnCreate(Bundle bundle)
        {
            TabLayoutResource = Resource.Layout.Tabbar;
            ToolbarResource = Resource.Layout.Toolbar;

            base.OnCreate(bundle);

            Xamarin.Forms.Forms.ViewInitialized += Forms_ViewInitialized;
            global::Xamarin.Forms.Forms.Init(this, bundle);
            LoadApplication(new App());
        }

        void Forms_ViewInitialized(object sender, Xamarin.Forms.ViewInitializedEventArgs e)
        {
            if (e.NativeView is SfChart)
            {
                var formsChart = e.View as Forms.SfChart;
                var nativeChart = (SfChart)e.NativeView as SfChart;

                for (int i = 0; i < nativeChart.Series.Count; i++)
                {
                    if (nativeChart.Series[i] is SplineAreaSeries)
                    {
                        nativeChart.Series.RemoveAt(i);
                        CustomSeries lineSeries = new CustomSeries();
                        SfChartRenderer.SetNativeObject(typeof(Forms.SplineAreaSeries), formsChart.Series[i], lineSeries);
                        nativeChart.Series.Insert(i, lineSeries);

                        var properties = SfChartRenderer.GetPropertiesChanged(typeof(Forms.SplineAreaSeries), formsChart.Series[i]);

                        foreach (string propName in properties)
                        {
                            ChartSeriesMapping.OnSplineAreaSeriesPropertiesChanged(propName, (Forms.SplineAreaSeries)formsChart.Series[i], lineSeries as SplineAreaSeries);
                        }

                        PropertyInfo formsSeriesInfo = typeof(ChartSeries).GetProperty("FormsSeries", BindingFlags.NonPublic | BindingFlags.Instance);
                        Forms.ChartSeries formsSeries = (Forms.ChartSeries)formsSeriesInfo.GetValue(lineSeries, null);
                        formsSeries = formsChart.Series[i];
                        formsSeriesInfo.SetValue(lineSeries, formsSeries);
                    }
                }
            }
        }
    }
}